package de.killig.j2me;

import java.io.IOException;
import java.util.*;

import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;

import de.killig.j2me.lcdui.SKForm;
import java.io.InputStream;

public class Timers extends MIDlet implements CommandListener,ItemCommandListener {

	private Command addCmd = new Command("Add", Command.SCREEN, 3);
	private Command startItemCmd = new Command("Start", Command.ITEM, 4);
	private Command pauseItemCmd = new Command("Pause", Command.ITEM, 1);
	private Command resumeItemCmd = new Command("Resume", Command.ITEM, 1);
	private Command removeItemCmd = new Command("Remove", Command.ITEM, 4);
  private Command aboutCmd = new Command("About", Command.HELP, 2);
  private Command exitCmd = new Command("Exit", Command.EXIT, 5);
	
  private boolean firstTime;
  private SKForm mainForm;
  
  static Timer t;
  //Player p;

  int now() {
    return (int)(new Date().getTime()/1000);
  }

  TimerTask refresh=new TimerTask() {
 	
		public void run() {
			TimerGauge item;
      int v;
			int l=now();
			for(int i=0;i<mainForm.size();i++) {
        item=(TimerGauge)mainForm.get(i);
        if(item.active) {
          if(item.stopwatch) {
            v=l-item.start;
          } else {
            v=item.start+item.len-l;
            if(v<=0) {
              /*try {
                p.start();
              } catch (Exception e) {
                e.printStackTrace();*/
                //try {
                  //Manager.playTone(ToneControl.C4, 50, 100);
                  item.setDefaultCommand(removeItemCmd);
                  AlertType.ALARM.playSound(Display.getDisplay(Timers.this));
                  Display.getDisplay(Timers.this).flashBacklight(50);
                  Display.getDisplay(Timers.this).vibrate(50);
                /*} catch (MediaException ex) {
                  ex.printStackTrace();
                  try {
                    //p = Manager.createPlayer(getClass().getResourceAsStream("/res/ding.wav"), "audio/X-wav");
                    if(p==null) p = Manager.createPlayer("http://sven.killig.de/Timers/ding.wav");
                    p.start();
                  } catch (Exception e) {
                    e.printStackTrace();
                  }
                }*/
              //}
            }
          }
          item.setValue(v);
        }
			}
		}
  };

  public Timers() {
    firstTime = true;
    mainForm = new SKForm("Timers");
	}

	protected void startApp() throws MIDletStateChangeException {
    //System.out.println("startApp()");
  	if(firstTime) {
      mainForm.addCommand(addCmd);
      mainForm.addCommand(aboutCmd);
      mainForm.addCommand(exitCmd);
      mainForm.setCommandListener(this);
      firstTime = false;
  	}
  	Display.getDisplay(this).setCurrent(mainForm);
    commandAction(addCmd, mainForm);
	}

	protected void pauseApp() {
    //System.out.println("pauseApp()");
	}

	protected void destroyApp(boolean unconditional) throws MIDletStateChangeException {
	}

	public void commandAction(Command c, Displayable d) {
    if(c==addCmd) {
			//v.addElement(new MyTimerTask(noTasks));
			Form editForm=new Form("New Timer");
			final DateField df=new DateField("Duration", DateField.TIME);
      /*Calendar cal=Calendar.getInstance();
      cal.set(Calendar.HOUR_OF_DAY, 0);
      cal.set(Calendar.MINUTE, 0);
      df.setDate(cal.getTime());*/
      String[] stringArray = {"Timer", "Stopwatch"};
      final ChoiceGroup cg=new ChoiceGroup("Mode", ChoiceGroup.EXCLUSIVE, stringArray, null);
			editForm.append(df);
			editForm.append(cg);
			final Command setCmd = new Command("Set", Command.OK, 1);
			editForm.addCommand(setCmd);
			editForm.addCommand(exitCmd);
			Display.getDisplay(this).setCurrent(editForm);
			editForm.setCommandListener(new CommandListener() {
				public void commandAction(Command c, Displayable d) {
          if(c==exitCmd) {
            try {
              destroyApp(false);
              notifyDestroyed();
            } catch (MIDletStateChangeException ex) {
              ex.printStackTrace();
            }
          } else if(c==setCmd) {
            TimerGauge tg=new TimerGauge((int)((df.getDate().getTime()+TimeZone.getDefault().getRawOffset())/1000), cg.getSelectedIndex()!=0);
            tg.addCommand(startItemCmd);
            tg.setDefaultCommand(pauseItemCmd);
            tg.addCommand(removeItemCmd);
            tg.setItemCommandListener(Timers.this);
            mainForm.append(tg);
            Display.getDisplay(Timers.this).setCurrent(mainForm);
            if(mainForm.size()==1) {
              t=new Timer();
            	t.schedule(refresh,0,1000);
            }
            /*try {
              p = Manager.createPlayer(getClass().getResourceAsStream("/res/ding.wav"), "audio/X-wav");
            } catch (Exception e) {
              e.printStackTrace();
            }*/
          }
				}
			});
    } else if(c==aboutCmd) {
      Image i=null;
      try {
        i = Image.createImage(getClass().getResourceAsStream("/res/timer.png"));
      } catch (IOException ex) {
        ex.printStackTrace();
      }
      Alert a;
      a = new Alert("Timers", "Written 2004 on a vacation in Portugal by Sven Killig", i, AlertType.INFO);
      /*Form aboutForm = new Form("About");
      aboutForm.append("Written 2004 in Portugal by Sven Killig");
      String url="http://sven.killig.de";
      aboutForm.append(new StringItem(null, url, Item.HYPERLINK));*/
      /*try {
        platformRequest(url);
      } catch (ConnectionNotFoundException ex) {
        ex.printStackTrace();
      }*/
      final Command webCommand=new Command("Web",Command.SCREEN,2);
      a.addCommand(webCommand);
      final Command backCommand=new Command("Back",Command.BACK,1);
      a.addCommand(backCommand);
			a.setCommandListener(new CommandListener() {
				public void commandAction(Command c, Displayable i) {
          if(c==backCommand) {
            Display.getDisplay(Timers.this).setCurrent(mainForm);
          } else if(c==webCommand) {
            try {
              platformRequest("http://sven.killig.de");
            } catch (Exception e) {
              e.printStackTrace();
            }
          }
        }
      });
      a.setTimeout(Alert.FOREVER);
      Display.getDisplay(this).setCurrent(a);
      //Display.getDisplay(this).setCurrent(aboutForm);
  	} else if(c==exitCmd) {
      try {
        destroyApp(false);
        notifyDestroyed();
      } catch (MIDletStateChangeException ex) {
        ex.printStackTrace();
      }
    }
  }

	public void commandAction(Command c, Item i) {
    TimerGauge tg=(TimerGauge)i;
    if(c==removeItemCmd) {
      //tg.cancel();
      mainForm.delete(i);
      if(mainForm.size()==0) {
      	t.cancel();
        commandAction(addCmd, mainForm);
      }
    } else if(c==pauseItemCmd) {
      tg.active=false;
      tg.pause=now();
      tg.removeCommand(pauseItemCmd);
      tg.setDefaultCommand(resumeItemCmd);
    } else if(c==resumeItemCmd) {
      tg.start+=now()-tg.pause;
      tg.removeCommand(resumeItemCmd);
      tg.setDefaultCommand(pauseItemCmd);
      tg.active=true;
    } else if(c==startItemCmd) {
      tg.start=now();
      tg.active=true;
    }
	}

	/*interface Timable {
    
  }*/
  class TimerGauge extends Gauge {
		
		boolean active=true,stopwatch;
		//TimerTask tt;
		int len,start,pause;
		
		public TimerGauge(int len, boolean stopwatch) {
			super(null, true, len, 0);
			start=now();
      if(!stopwatch) setValue(len);
			this.len=len;
      this.stopwatch=stopwatch;
			/*tt=new TimerTask() {
				public void run() {
					try {
				    InputStream is = getClass().getResourceAsStream("/ding.wav");
				    Player p = Manager.createPlayer(is, "audio/X-wav");
				    p.start();
					} catch (Exception e) {
						e.printStackTrace();
					}
				}
			};*/
			//t.schedule(tt,new Date(new Date().getTime()+len*1000));
		}
		
		/*public void cancel() {
			tt.cancel();
		}*/

    public void setValue(int value) {
      super.setValue(value);
      String p=value<0?"-":"";
      value=Math.abs(value);
      String s=value%60<10? "0":"";
      setLabel(p+value/60+":"+s+value%60);
    }
		
	}

}

/*class MyTimerTask extends TimerTask {
	
	int id;
	
	public MyTimerTask(int id) {
		this.id=id;
	}
	
	public void run() {
	}
}*/
